package com.diagbot.repository;

import com.diagbot.entity.node.EntityInfo;
import com.diagbot.entity.node.MedJiePouClass;
import org.springframework.data.neo4j.annotation.Query;
import org.springframework.data.neo4j.repository.Neo4jRepository;
import org.springframework.data.repository.query.Param;

import java.util.List;


public interface MedJiePouClassRepository extends Neo4jRepository<MedJiePouClass, Long> {

    List<MedJiePouClass> findByNameIs(String name);

    List<MedJiePouClass> findByNameContaining(String name);

    @Query("create (n:药品解剖学类别) \n" +
            "set  " +
            "n.name = :#{#entityInfo.name}," +
            "n.拼音编码 = :#{#entityInfo.pycode}," +
            "n.静态知识标识 = :#{#entityInfo.is_kl}," +
            "n.状态 = :#{#entityInfo.status}" +
            "\n" +
            "RETURN n,[ (n)-[r]->(m) | [ r, m ] ], ID(n)\n")
    MedJiePouClass create(@Param("entityInfo") EntityInfo entityInfo);
}

