package com.diagbot.repository;

import com.diagbot.entity.node.EntityInfo;
import com.diagbot.entity.node.MedRegName;
import org.springframework.data.neo4j.annotation.Query;
import org.springframework.data.neo4j.repository.Neo4jRepository;
import org.springframework.data.repository.query.Param;

import java.util.List;


public interface MedRegNameRepository extends Neo4jRepository<MedRegName, Long> {

    List<MedRegName> findByNameIs(String name);

    List<MedRegName> findByNameContaining(String name);

    @Query("match (n:药品注册名称) \n" +
            "where id(n) = :#{#entityInfo.id} \n" +
            "set  " +
            "n.name = :#{#entityInfo.name}," +
            "n.拼音编码 = :#{#entityInfo.pycode}," +
            "n.静态知识标识 = :#{#entityInfo.is_kl}," +
            "n.状态 = :#{#entityInfo.status}," +
            "n.药品高危级别 = {risklevel}," +
            "n.禁忌给药途径 = {conflict_geiyao}," +
            "n.禁忌性别 = {conflict_gender}," +
            "n.结果 = {result}," +
            "n.名称 = {alias}" +
            "\n" +
            "RETURN n,[ (n)-[r]->(m) | [ r, m ] ], ID(n)\n")
    MedRegName update(@Param("entityInfo") EntityInfo entityInfo,
                      @Param("risklevel") String risklevel,
                      @Param("conflict_geiyao") String conflict_geiyao,
                      @Param("conflict_gender") String conflict_gender,
                      @Param("result") String result,
                      @Param("alias") String alias);

    @Query("create (n:药品注册名称) \n" +
            "set  " +
            "n.name = :#{#entityInfo.name}," +
            "n.拼音编码 = :#{#entityInfo.pycode}," +
            "n.静态知识标识 = :#{#entityInfo.is_kl}," +
            "n.状态 = :#{#entityInfo.status}," +
            "n.药品高危级别 = {risklevel}," +
            "n.禁忌给药途径 = {conflict_geiyao}," +
            "n.禁忌性别 = {conflict_gender}," +
            "n.结果 = {result}," +
            "n.名称 = {alias}" +
            "\n" +
            "RETURN n,[ (n)-[r]->(m) | [ r, m ] ], ID(n)\n")
    MedRegName create(@Param("entityInfo") EntityInfo entityInfo,
                      @Param("risklevel") String risklevel,
                      @Param("conflict_geiyao") String conflict_geiyao,
                      @Param("conflict_gender") String conflict_gender,
                      @Param("result") String result,
                      @Param("alias") String alias);
}

